/* Copyright(C) 2004 Brazil

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include <sys/param.h>

#ifndef _SEN_SYM_H
#define _SEN_SYM_H

#ifndef _SENNA_H
#include "senna_in.h"
#endif /* _SENNA_H */

#ifndef _SEN_SET_H
#include "set.h"
#endif /* _SEN_SET_H */

#ifndef _SEN_STR_H
#include "str.h"
#endif /* _SEN_STR_H */

#ifndef _SEN_IO_H
#include "io.h"
#endif /* _SEN_IO_H */

#ifdef	__cplusplus
extern "C" {
#endif

#define SEN_SYM_WITH_SIS 0x80000000

#define SEN_SYM_SEGMENT_SIZE 0x400000
#define SEN_SYM_MAX_SEGMENT 512

#define SEN_SYM_MAX_ID 134217727L
#define SEN_SYM_NIL 0

struct _sen_sym {
  sen_io *io;
  struct sen_sym_header *header;
  uint32_t flags;
  sen_encoding encoding;
  uint32_t key_size;
  sen_io_seginfo keyarray[SEN_SYM_MAX_SEGMENT];
  sen_io_seginfo patarray[SEN_SYM_MAX_SEGMENT];
  sen_io_seginfo sisarray[SEN_SYM_MAX_SEGMENT];
};

#ifdef __cplusplus
}
#endif

#endif /* _SEN_SYM_H */
